header
lorom

!FREESPACE = $158000

org $008C81     ;status bar tilemap                
db $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC	;That's the four tiles for the top of the item box

db $30,$28,$31,$28,$32,$28,$33,$28,$34,$28		;Mario
db $FC,$FC,$FC,$FC,$FC,$3C,$FC,$3C,$FC,$3C,$FC,$FC
db $FC,$3C,$3D,$3C,$3E,$3C				;TIME
db $3F,$3C,$FC,$38,$FC,$38
db $2E,$3C,$26,$38,$FC,$38				;Coin symb.
db $FC,$38,$00,$38,$FC,$3C,$40,$28	;|of the
db $41,$28,$42,$28,$43,$28,$44,$28	;/status bar

db $FC,$38,$26,$38,$FC,$38,$05,$38	;\Second
db $FC,$38,$FC,$3C,$FC,$FC,$FC,$28	;|Line
db $FC,$3C,$FC,$3C,$FC,$3C,$FC,$3C	;|of
db $FC,$3C,$FC,$3C,$FC,$38,$FC,$38	;|the
db $FC,$38,$FC,$38,$FC,$38,$FC,$38	;|status
db $FC,$38,$00,$38,$FC,$3C,$26,$38	;|bar
db $FC,$38,$05,$38,$FC,$3C,$FC,$3C	;/but the last two bytes are not
db $FC,$3C,$FC,$3C,$FC,$3C		;bottom 4 tiles of the item box

org $008E72
STA $0F20               ;  | 
LDA $0F32               ;  |shift time five to the left
STA $0F21               ;  | 
LDA $0F33               ;  | 
STA $0F22

org $008F7E
STA $0F0E
STX $0F0D

org $008F55
STX $0F17		;\shift lives one to the right
STA $0F18		;/
JMP $8F73		; Kill bonus stars

org $008F86
LDA $06A2
BNE TwoPlayerDraw
LDA #$FC
STA $0F10
STA $0F11
STA $0F12
STA $0F13
STA $0F14
STA $0F2C
STA $0F2E
STA $0F2D
RTS
TwoPlayerDraw:
LDA $06A1
INC
JSL $00974C
STA $0F2E
STX $0F2D
CPX #$00
BNE NoNeedEnd
LDA #$FC
STA $0F2D
NoNeedEnd:
RTS

org $008ED8
db $0F			;move score back 0B

org $008EE2
db $22

org $008EE9
db $22

org $009E13
JSL PlayerCode

org $008F32
JSL CoinLife

org $01C545
NOP
NOP
NOP


!SLOTSUSED = $06FE	;how many slots have been used - for DSX.asm
org $82BC
	REP #$30
	PLB
	PLY

;FastROM registration data
org $7FD5
	db $30

org $816A
	JML DSXStart

org !FREESPACE
db "STAR"
dw END_FREESPACE-MAIN_ROUTINE
dw END_FREESPACE-MAIN_ROUTINE^#$FFFF

MAIN_ROUTINE:
PHB
PHK
PLB
LDA $9D
BNE DORETURN

LDA $14C8,x		;\
CMP #$08		; | If the sprite is dead or not it its normal state, return.
BEQ DONTRETURN		;/
DORETURN:
JMP RETURN
DONTRETURN:
JSL $01802A	;update positions by speed

LDA $06A0
BIT #$40
BEQ NOTDEADYET
STZ $B6,x
JMP RETURN
NOTDEADYET:

LDA $1588,x
BIT #$04
BEQ .offtheground
STZ $06A6
.offtheground


STZ $0D
LDA $06A0
ASL
ORA $06A0
BIT #$02
BNE .doregngng
BIT #$10
BEQ .doregngng
JSR GetSpriteClipping
BRA .egreg
.doregngng
JSL $03B6E5		;Get clipping for self
.egreg
PHX			;Preserve sprite #
LDX #$0C		;Load # of sprites
INTRLOOP:
DEX			;next sprite
BMI ABORTINTR		;If done, end
LDA $14C8,x
BEQ INTRLOOP
TXA
CMP $01,s
BEQ INTRLOOP
JSL $03B69F		;get clipping for client sprite
JSL $03B72B		;Check for contact
BCC INTRLOOP		;if no contact, continue loop
LDA $14C8,x
CMP #$08
BCC INTRLOOP
INC $0D
TXY			;client sprite index to Y
PLX			;own sprite index to X
JSR SPRITE_INTERACT	;interact
PHX			;preserve self index
TYX			;client back to X
BRA INTRLOOP		;continue loop
ABORTINTR:
PLX			;Finished. Get self sprite index back
INTREND:

LDY #$0B
GoalLoop:										;GOAL
LDA $009E,y
CMP #$7B
BEQ CheckSprite
NotIt:
DEY
BPL GoalLoop
BRA EndGoal
CheckSprite:
LDA $00E4,y
LSR
LSR
STA $00
LDA $E4,x
LSR
LSR
CMP $00
BNE NotIt
LDA $14E0,y
CMP $14E0,x
BNE NotIt
LDA $14C8,y
CMP #$08
BNE NotIt
PHX
TYX
JSL EndLevel
PLX
LDA #$40
STA $151C,x
EndGoal:

LDA $1493
BEQ NoWalkZom
STZ $0DA3
STZ $0DA5
STZ $14A7
STZ $14A9
LDA #$06
STA $B6,x
JMP ObjIntr
NoWalkZom:

;DUCKING/LOOKING UP

LDA $1588,x
BIT #$04
BEQ .inAir
LDA $B6,x
BNE .trydown
LDA $0DA3
BIT #$08
BEQ .noup
LDA #$20
TSB $06A0
BRA .trydown
.noup
LDA #$20
TRB $06A0
.trydown
LDA $0DA3
BIT #$04
BEQ .nodown
LDA #$02
TSB $06A0
BRA .end
.nodown
LDA $1588,x
BIT #$04
BEQ .end
LDA #$02
TRB $06A0
BRA .end
.inAir
LDA #$20		;cancel looking up
TRB $06A0
.end
LDA $B6,x
BEQ .ngngngng
LDA #$20
TRB $06A0
.ngngngng
											;JUMPING
LDA $1588,X		;\If not on ground
BIT #$04		; |
BEQ LABELNAME_3		;/don't jump
LDA #$01
TRB $06A0
STZ $06A3
LDA $0DA7		;\if pressing B
ORA $0DA9		; |or A
BIT #$80		; |
BEQ NOJUMP		;/jump
LDA $B6,x		;\Get x-speed
BPL POSJMP		; |if negitive
EOR #$FF		; |then make positive
POSJMP:			; |
LSR			; |shift right
LSR			; |twice
STA $00			; |set to scratch ram
LDA #$C0		; |load base speed
SEC			; |and subtract
SBC $00			; |the calculation
STA $AA,x		;/set as y-speed
LDA $0DA9
BIT #$80
BNE SPINJUMP 
REGJUMP:	;REGULAR JUMP 
LDA $B6,x
STA $06A6
LDA #$01		;\set jumping sound effect
STA $1DFA		;/
BRA NOJUMP
SPINJUMP:	;SPIN-JUMP
LDA #$01
TSB $06A0
LDA #$22
TRB $06A0
LDA #$04		;\spinjump sound
STA $1DFC		;/
BRA NOJUMP
LABELNAME_3:
LDA $0DA3		;\If pressing B
ORA $0DA5		; |or A
AND #$80		; |
BEQ NOJUMP		;/Fall slower
DEC $AA,x
NOJUMP:
	

LDA $1588,x										;MOVEMENT
BIT #$04
BEQ .bypassduck
LDA $06A0
BIT #$02
BNE LABELNAME_4
.bypassduck
LDA $0DA3		;\Get controller data
BIT #$01		; |if press right
BNE MOVERIGHT		; |move right
BIT #$02		; |if not press left
BEQ LABELNAME_4		;/don't move
		;LEFT
LDA $B6,x		;\If x-speed is positive
BEQ SPEEDUP_LEFT
BMI NOTURN_LEFT		;/turn around
INC $1558,x
DEC
DEC
DEC			;\deccrement x-speed
DEC			; |four times
STA $B6,x		;/
BRA NOMOVE
NOTURN_LEFT:
LDA $0DA3		;\if pressing x/y
ORA $0DA5		; |
BIT #$40		; |run
BEQ WALKING_LEFT	;/otherwise, walk
LDA #$D0		;running speed
BRA LABELNAME_2
WALKING_LEFT:
LDA #$EA		;walking speed
LABELNAME_2:
CMP $B6,x		;\if speed is less than target
BCC SPEEDUP_LEFT	;/speed up
INC $B6,x		;\slow down
INC $B6,x		;/twice b/c I'm too lazy to BRA
SPEEDUP_LEFT:
DEC $B6,x		;speed up
BRA NOMOVE
		;RIGHT
MOVERIGHT:
LDA $B6,x		;\If x-speed is negitive
BPL NOTURN_RIGHT	;/turn around
INC $1558,x
INC
INC
INC			;\Increment x-speed
INC			; |four times
STA $B6,x		;/
BRA NOMOVE
NOTURN_RIGHT:
LDA $0DA3		;\if pressing x/y
ORA $0DA5		; |
BIT #$40		; |run
BEQ WALKING_RIGHT	;/otherwise, walk
LDA #$30		;running speed
BRA LABELNAME_1
WALKING_RIGHT:
LDA #$15		;walking speed
LABELNAME_1:
CMP $B6,x		;\if speed is less than target
BCS SPEEDUP_RIGHT	;/speed up
DEC $B6,x		;\slow down
DEC $B6,x		;/twice b/c I'm too lazy to BRA
SPEEDUP_RIGHT:
INC $B6,x		;speed up
BRA NOMOVE
LABELNAME_4:
LDA $1588,x
BIT #$04
BEQ NOMOVE
LDA $B6,x
BEQ NOMOVE
BPL STOPDEC
INC
INC
STOPDEC:
DEC
STA $B6,x
NOMOVE:

											

DoSlideSmoke:
LDA $1588,x
BIT #$04
BEQ .end
LDA $1558,x
BNE .yesyesyes
LDA $06A0
AND #$02
BEQ .end
LDA $B6,x
BEQ .end
.yesyesyes
LDA $14
BIT #$03
BNE .end
LDY #$00
.loopstart
LDA $17C0,y
BEQ .loopsuccess
INY
CPY #$04
BNE .loopstart
BRA .end
.loopsuccess
LDA #$03
STA $17C0,y
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
CLC
ADC #$0006
SEP #$20
STA $17C8,y
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
CLC
ADC #$0009
SEP #$20
STA $17C4,y
LDA #$12
STA $17CC,y
.end


											;DON'T WALK OFF SCREEN
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC $1A
SEP #$20
CMP #$08
BCS NotFarLeft
REP #$20
LDA $1A			;layer 1 xpos
CLC
ADC #$0008
SEP #$20
STA $E4,x
XBA
STA $14E0,x		;...plus 8 to sprite xpos
LDA $1588,x
ORA #$02
STA $1588,x
BRA NotFarRight
NotFarLeft:
CMP #$E8
BCC NotFarRight
REP #$20
LDA $1A
CLC
ADC #$00E8
SEP #$20
STA $E4,x
XBA
STA $14E0,x
LDA $1588,x
ORA #$01
STA $1588,x
NotFarRight:

LDA $06A0										;FIREBALL TOSSING
AND #$18
EOR #$18
BNE NoFireSA		;decide if tossing should actually occour

LDA $06A0
BIT #$02
BNE NoFireSA
STZ $00
LDA $06A0
BIT #$01
BEQ TryAButtonIfYouWill
LDA $14
AND #$0F
BNE NoFireSA
LDA #$01
STA $00
BRA OhHoHoHoLookWhatIveDone

NoFireSA:
JMP NoFireS

TryAButtonIfYouWill:
LDA $0DA7
ORA $0DA9
BIT #$40
BEQ NoFireSA

OhHoHoHoLookWhatIveDone:
LDY #$00
EXTRA_LOOP:
LDA $1713,y
BEQ EXTRA_1		;get new extended sprite index
INY
CPY #$02
BNE EXTRA_LOOP
BRA NoFireS
EXTRA_1:

LDA #$05
STA $1713,y		;set fireball exists
LDA #$10
STA $1745,y		;y-speed

LDA $00
BEQ .DoItRegular
LDA $157C,x
PHA
LDA $14
AND #$10
LSR
LSR
LSR
LSR
STA $157C,x
.DoItRegular
LDA $157C,x
BEQ ShootFireLeft	; = 03 if facing right
LDA #$03		;if facing right, shoot right
STA $174F,y
BRA EndXfire
ShootFireLeft:
LDA #$FD		;if facing left, shoot left
STA $174F,y
EndXfire:
LDA $00
BEQ .DoItRegular
PLA
STA $157C,x
.DoItRegular

LDA $14D4,x		;ypos, high byte
XBA
LDA $D8,x		;ypos, low byte
REP #$20
SEC
SBC #$0005
SEP #$20
STA $171D,y
XBA
STA $1731,y
LDA $E4,x		;xpos, low byte
STA $1727,y
LDA $14E0,x		;xpos, high byte
STA $173B,y
LDA $157C,x
BEQ .rawrz
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
CLC
ADC #$0008
SEP #$20
STA $1727,y
XBA
STA $173B,y
.rawrz
LDA #$06
STA $1DFC
LDA $00
BNE NoFireS
LDA #$0A
STA $154C,x
NoFireS:

BRA ObjIntr

											;OBJECT INTERACTION
WhatToInteractWith:
db $00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$02

ObjIntr:
LDA $E4,x
AND #$0F
TAY
LDA WhatToInteractWith,y
STA $0F
LDA $D8,x
AND #$0F
TAY
LDA WhatToInteractWith,y
STA $0E
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
LSR #4
STA $0A
SEP #$20
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
LSR #4
STA $0C
SEP #$20
LDA #$00
XBA
LDA $0F
REP #$20
LSR
CLC
ADC $0C
STA $0C
SEP #$20
LDA $0F
AND #$01
INC
STA $0F
STZ $09
LDA $06A0
AND #$18
BEQ NoNopeNotAPowerup
INC $09
NoNopeNotAPowerup:
LDA #$00
XBA
LDA $0E
REP #$20
LSR
CLC
ADC $0A
STA $0A
SEP #$20
LDA $0E
AND #$01
INC
CLC
ADC $09
STA $0E

STZ $08
STZ $09
OuterLoop:
STZ $08
LDA #$00	;\
XBA		; |
LDA $09		; |
REP #$20	; |
ASL #4		; |
STA $00		; |$00 = ($0A << 4) + ($09 << 4)
LDA $0A		; |
LSR #4		; |
CLC		; |
ADC $00		; |
STA $00		; |
SEP #$20	;/
InnerLoop:
LDA #$00	;\
XBA		; |
LDA $08		; |
REP #$20	; |
ASL #4		; |
STA $02		; |$02 = ($0C << 4) + ($08 << 4)
LDA $0C		; |
LSR #4		; |
CLC		; |
ADC $02		; |
STA $02		; |
SEP #$20	;/
JSR Block_Setup
LDA $08
INC
STA $08
CMP $0F
BNE InnerLoop
LDA $09
INC
STA $09
CMP $0E
BNE OuterLoop




											;KILL IF SQUASHED
LDA $1588,x
AND #$03
EOR #$03
BNE kjoin
JSR KillLuigi
kjoin:
											;DIE IF FALL OFF SCREEN
REP #$20
LDA $1C
CLC
ADC #$00E0
STA $00
SEP #$20
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
CMP $00
BCC NoDOffScr
SEP #$20
JSR KillLuigi
STZ $AA,x
STZ $14C8,x
NoDOffScr:
SEP #$20

											;KILL STAR IF DONE
LDA $1534,x
BEQ NoDoneM
LDA $1570,x
BNE NoDoneM
LDA $1534,x
STA $1DFB
LDA #$00
STA $1534,x
NoDoneM:

RETURN:
LDA $1540,x
AND #$02
BNE NOGFX
LDA $1338
JSR SUB_GFX
NOGFX:
PLB
RTL

;List of frames:
;
;0 - standing, small
;1 - walking, small
;2 - standing, big
;3 - walking, big
;4 - walking 2, big
;5 - jumping, small
;6 - jumping, big
;7 - falling, small
;8 - falling, big
;9 - facing screen, small
;A - facing screen, big
;B - facing BG, small
;C - facing BG, big
;D - Dead
;E - Peace, small
;F - Peace, big
;10 - Sprint A, small
;11 - Sprint B, small
;12 - Sprint A, big
;13 - Sprint B, big
;14 - Sprint C, big
;15 - Sprint jump, small
;16 - Sprint jump, big
;17 - Fireball
;18 - Fireball, midair
;19 - ducking, small
;1A - ducking, big
;1B - looking up, small
;1C - looking up, big
;1D - turning around, small
;1E - turning around, big

FootDynams:
db $30,$30,$01,$00,$00,$91,$01,$92
db $61,$72,$03,$63,$00,$82,$73,$53
db $42,$43,$02,$01,$01,$52,$02,$51
db $11,$A3,$03,$80,$01,$92,$02
FootTiles:
db $22,$00,$00,$02,$00,$22,$02,$20
db $20,$02,$02,$00,$20,$22,$00,$22
db $20,$20,$20,$22,$20,$20,$22,$02
db $22,$00,$00,$22,$00,$22,$00
HeadDynams:
db $20,$20,$30,$30,$30,$91,$32,$92
db $63,$62,$42,$53,$40,$82,$63,$51
db $20,$20,$30,$30,$30,$20,$30,$41
db $30,$62,$62,$80,$50,$92,$30
HeadTiles:
db $20,$20,$20,$20,$20,$02,$20,$00
db $02,$22,$00,$20,$20,$20,$20,$22
db $20,$20,$20,$20,$20,$20,$20,$22
db $20,$02,$02,$02,$00,$02,$20
SUB_GFX:										;GRAPHICS

LDA $1337
JSR CalcDir
JSR CalcFrame		;Current Frame should be stored in $05

LDY $05
LDA FootDynams,y
JSR GETSLOT
PHA
LDY $05
LDA HeadDynams,y
JSR GETSLOT
PHA
JSR GET_DRAW_INFO

LDA $05
CMP #$01
BEQ deep
CMP #$04
BEQ deep
CMP #$11
BEQ deep
CMP #$14
BEQ deep
BRA nodeep
deep:
DEC $01
nodeep:
TYA
LSR
LSR
TAX
LDA #$02
STA $0460,x
STA $0461,x
STX $06
LDA $00
LDX $05
STA $0300,y
STA $0304,y
LDA $01
STA $0305,y
SEC
SBC #$10
STA $0301,y
PLA
CLC
ADC HeadTiles,x
STA $0302,y
PLA
CLC
ADC FootTiles,x
STA $0306,y
LDX $15E9
LDA $157C,x
CLC
ROR #3
ORA #$3D
STA $08
LDA $06A0
LSR
AND $06A0
AND #$08
LSR
LSR
EOR #$02
CLC
ADC $08
STA $0303,y
STA $0307,y

LDA $05
CMP #$12
BEQ RunExtra
CMP #$13
BEQ RunExtra
CMP #$14
BEQ RunExtra
CMP #$16
BEQ JumpExtra
CMP #$18
BEQ FireExtrax

LDY #$02
LDA #$01
JSL $01B7B3
RTS

FireExtrax:
JMP FireExtra

FLOFSET:
db $10,$F8
RunExtra:
PHX
LDX $06
STZ $0462,x
STZ $0463,x
PLX
LDA $157C,x
TAX
LDA $00
CLC
ADC FLOFSET,x
STA $0308,y	;x
LDA $01
STA $0309,y	;y
LDA #$0C
STA $030A,y	;tile
LDX $15E9
LDA $157C,x
CLC
ROR #3
ORA #$3C
STA $08
LDA $06A0
LSR
AND $06A0
AND #$08
LSR
LSR
EOR #$02
CLC
ADC $08
STA $030B,y	;props
LDA #$02
LDY #$FF
JSL $01B7B3
RTS

JumpExtra:
LDA $157C,x
TAX
LDA $00
CLC
ADC FLOFSET,x
STA $0308,y	;x1
STA $030C,y	;x2
LDA $01
STA $0309,y	;y1
CLC
ADC #$08
STA $030D,y	;y2
LDA #$1A
STA $030A,y	;tile1
INC
STA $030E,y	;tile2
LDX $15E9
LDA $157C,x
CLC
ROR #3
ORA #$3C
STA $08
LDA $06A0
LSR
AND $06A0
AND #$08
LSR
LSR
EOR #$02
CLC
ADC $08
STA $030B,y	;props1
STA $030F,y	;props2
LDA #$03
LDY #$FF
JSL $01B7B3
RTS

FireExtra:
LDA $157C,x
TAX
LDA $00
CLC
ADC FLOFSET,x
STA $0308,y	;x1
STA $030C,y	;x2
LDA $01
STA $0309,y	;y1
CLC
ADC #$08
STA $030D,y	;y2
LDA #$22
STA $030A,y	;tile1
INC
STA $030E,y	;tile2
LDX $15E9
LDA $157C,x
CLC
ROR #3
ORA #$3C		;has to be fire palette due to context
STA $030B,y	;props1
STA $030F,y	;props2
LDA #$03
LDY #$FF
JSL $01B7B3
RTS




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;		Y = index to sprite OAM ($300)
;		$00 = sprite x position relative to screen boarder
;		$01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1:             db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:      STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:        LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040              ;  |
                    CMP #$0180              ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:     LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:        DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID:            PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;2kb buffer is at 7F:0B44.  It is copied in one chunk to VRAM on NMI.
;variables for following routine
;based off smwedit's code
!SLOTPTR = $0660	;16bit pointer for source GFX
!SLOTBANK = $0662	;bank
!SLOTDEST = $0663	;VRAM address
!SLOTSUSED = $06FE	;how many slots have been used

!MAXSLOTS = $04		;maximum selected slots

SLOTS:
db $CC,$C8,$C4,$C0	;avaliable slots.  Any more transfers and it's overflowing by a dangerous amount.

GETSLOT:
	PHY		;preserve OAM index
	PHA		;preserve frame
	LDA !SLOTSUSED	;test if slotsused == maximum allowed
	CMP #!MAXSLOTS
	BEQ NoneFree

	PLA		;pop frame
	REP #$20	;16bit A
	AND #$00FF	;wipe high
	XBA		;<< 8
	LSR A		;>> 1 = << 7
	STA $00		;back to scratch
	PEA.w Graphics	;push 16bit address, since i'm not sure how else i'm going to get the address of the label itself in TRASM
	PLA		;pull 16bit address
	CLC
	ADC $00		;add frame offset	
	STA !SLOTPTR	;store to pointer to be used at transfer time
	SEP #$20	;8bit store
	PHB		;push db...
	PLA		;pull to A...
	STA !SLOTBANK	;store bank to 24bit pointer

	LDY !SLOTSUSED	;calculate VRAM address + tile number
	LDA SLOTS,y	;get tile# in VRAM
	PHA		;preserve for eventual pull
	SEC
	SBC #$C0	;starts at C0h, they start at C0 in tilemap
	REP #$20	;16bit math
	AND #$00FF	;wipe high byte
	ASL A		;multiply by 32, since 32 bytes/16 words equates to 1 32bytes tile
	ASL A
	ASL A
	ASL A
	ASL A
	CLC
	ADC #$0B44	;add 0B44, base address of buffer	
	STA !SLOTDEST	;destination address in the buffer

	JSR DMABUFFER	;ROM -> RAM copy

	SEP #$20	;8bit A	
	INC !SLOTSUSED	;one extra slot has been used

	PLA		;return starting tile number
	PLY
	RTS
		
NoneFree:
	PLA
	PLY
	LDA #$00	;zero on no free slots
	RTS

;;;;;;;;;;;;;;;;
;Tansfer routine
;;;;;;;;;;;;;;;;

;DMA ROM -> RAM ROUTINE

DMABUFFER:
;set destination RAM address
	REP #$20
	LDA !SLOTDEST
	STA $2181	;16bit RAM dest
	LDY #$7F
	STY $2183	;set 7F as bank

;common DMA settings
	STZ $4300	;1 reg only
	LDY #$80	;to 2180, RAM write/read
	STY $4301

;first line
	LDA !SLOTPTR
	STA $4302	;low 16bits
	LDY !SLOTBANK
	STY $4304	;bank
	LDY #$80	;128 bytes
	STY $4305
	LDY #$01
	STY $420B	;transfer

;SEP #$20
;RTS

;second line
	LDA !SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA !SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA !SLOTPTR	;update source address
	CLC
	ADC #$0200	;512 bytes, next row
	STA !SLOTPTR
	STA $4302	;low 16bits
	LDY !SLOTBANK
	STY $4304	;bank
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;third line!
	LDA !SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA !SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA !SLOTPTR	;update
	CLC
	ADC #$0200
	STA !SLOTPTR
	STA $4302
	LDY !SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;fourth line
	LDA !SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA !SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA !SLOTPTR
	CLC
	ADC #$0200
	STA !SLOTPTR
	STA $4302
	LDY !SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B

	SEP #$20	;8bit A
	RTS		;all done, return

SprClippingDispX:
db $00
SprClippingWidth:
db $10
SprClippingDispY:
db $F0
SprClippingHeight:
db $20

GetSpriteClipping:
PHY                       
PHX                       
TXY                       ; Y = Sprite index 
LDA #$00   ; \ X = Clipping table index 
AND #$3F                ;  | 
TAX                       ; / 
STZ $0F                   ; \ 
LDA SprClippingDispX,X  ;  | Load low byte of X displacement 
BPL CODE_03B6F8           ;  | 
DEC $0F                   ;  | $0F = High byte of X displacement 
CODE_03B6F8:
CLC                       ;  | 
ADC $00E4,Y     ;  | 
STA $00                   ;  | $00 = (Sprite X position + displacement) Low byte 
LDA $14E0,Y     ;  | 
ADC $0F                   ;  | 
STA $08                   ; / $08 = (Sprite X position + displacement) High byte 
LDA SprClippingWidth,X  ; \ $02 = Clipping width 
STA $02                   ; / 
STZ $0F                   ; \ 
LDA SprClippingDispY,X  ;  | Load low byte of Y displacement 
BPL CODE_03B715           ;  | 
DEC $0F                   ;  | $0F = High byte of Y displacement 
CODE_03B715:
CLC                       ;  | 
ADC $00D8,Y     ;  | 
STA $01                   ;  | $01 = (Sprite Y position + displacement) Low byte 
LDA $14D4,Y     ;  | 
ADC $0F                   ;  | 
STA $09                   ; / $09 = (Sprite Y position + displacement) High byte 
LDA SprClippingHeight,X ; \ $03 = Clipping height 
STA $03                   ; / 
PLX                       ; X = Sprite index 
PLY                       
RTS                       ; Return 


;;;;;;;;;
;
;Calculate Frame
;
;;;;;;;;;

CalcFrame:
LDA $06A0
LSR
ORA $06A0
LSR
LSR
LSR
AND #$01
STA $05
LDA $06A0
BIT #$40
BNE .dead
BIT #$22
BNE .lookupdown
LDA $1588,x
BIT #$04
BEQ .skipturncheck
LDA $1558,x
BNE .turnaround
.skipturncheck
LDA $154C,x
BNE .fireball
LDA $1588,x
BIT #$04
BEQ .inair
LDA $13E0
CMP #$26
BEQ .peace
LDA $B6,x
BNE  .moving
.stationary
LDA $05
ASL
STA $05
RTS
.dead
LDA $14
AND #$04
LSR
LSR
STA $157C,x
LDA #$0D
STA $05
RTS
.turnaround
LDA $05
CLC
ADC #$1D
STA $05
RTS
.lookupdown
LSR #4
AND #$02
ORA $05
CLC
ADC #$19
STA $05
RTS
.inair
JMP .inairh
.fireball
LDA $1588,x
LSR
LSR
AND #$01
EOR #$01
CLC
ADC #$17
STA $05
RTS
.peace
LDA #$0E
CLC
ADC $05
STA $05
STZ $AA,x
STZ $B6,x
RTS
.moving
LDA $05
BNE .movingandbig
LDA $14
AND #$08
LSR
LSR
LSR
STA $05
LDA $B6,x
JSR FrcPlus
CMP #$2C
BCC .walksmall
LDA $14
AND #$04
LSR
LSR
CLC
ADC #$10
STA $05
.walksmall
RTS
.MABT
db $02,$02,$03,$03,$03,$04,$04,$04
.MFAB
db $12,$13,$13,$14
.movingandbig
LDA $14
AND #$07
TAY
LDA .MABT,y
STA $05
LDA $B6,x
JSR FrcPlus
CMP #$2C
BCC .return
LDA $14
AND #$03
TAY
LDA .MFAB,y
STA $05
RTS
.return
LDA $14
AND #$0F
LSR
TAY
LDA .MABT,y
STA $05
RTS
.inairh
LDA $06A0
BIT #$01
BNE .spinjump
LDA $06A6
JSR FrcPlus
CMP #$2C
BCS .bjsj
LDA $AA,x
ROL #3
AND #$02
EOR #$02
ORA $05
CLC
ADC #$05
STA $05
RTS
.bjsj
LDA #$15
CLC
ADC $05
STA $05
RTS
.SJFS
db $00,$00,$09,$09,$00,$00,$0B,$0B
.DoAStandingRoll
JMP .stationary
.spinjump
LDA $14
AND #$04
LSR
LSR
STA $157C,x
LDA $14
AND #$07
TAY
LDA .SJFS,y
BEQ .DoAStandingRoll
CLC
ADC $05
STA $05
RTS

;List of frames:
;
;0 - standing, small
;1 - walking, small
;2 - standing, big
;3 - walking, big
;4 - walking 2, big
;5 - jumping, small
;6 - jumping, big
;7 - falling, small
;8 - falling, big
;9 - facing screen, small
;A - facing screen, big
;B - facing BG, small
;C - facing BG, big
;D - Dead
;E - Peace, small
;F - Peace, big
;10 - Sprint A, small
;11 - Sprint B, small
;12 - Sprint A, big
;13 - Sprint B, big
;14 - Sprint C, big
;15 - Sprint jump, small
;16 - Sprint jump, big
;17 - Fireball
;18 - Fireball, midair
;19 - ducking, small
;1A - ducking, big
;1B - looking up, small
;1C - looking up, big
;1D - turning around, small
;1E - turning around, big

;;;;;;;;;
;
;Calculate Direction:
;
;;;;;;;;;

CalcDir:
LDA $1493
BNE .alwaysright
LDA $0DA3
AND #$03
BEQ .return
AND #$01
STA $157C,x
.return
RTS
.alwaysright
LDA #$01
STA $157C,x
RTS

;;;;;;;;;
;
;Make Positive
;
;;;;;;;;;

FrcPlus:
BPL .return
EOR #$FF
INC
.return
RTS

;;;;;;;;;
;
;Hurt luigi
;
;;;;;;;;;

HurtLuigi:
LDA $1540,x
BNE NoNoNoNoNo
LDA $06A0
AND #$18
BEQ KillLuigi
LDA #$40
STA $1540,x
LDA #$04
STA $1DF9
LDA $06A0
AND -#$18
STA $06A0
NoNoNoNoNo:
RTS

;;;;;;;;;
;
;Kill luigi
;
;;;;;;;;;

KillLuigi:
LDA $06A0
ORA #$40
STA $06A0
LDA #$23
STA $1DF9
LDA $1686,x
ORA #$80
STA $1686,x
LDA #$A0
STA $AA,x
STZ $B6,x
DEC $06A1
RTS

;;;;;;;;;
;
;Where on the sprite
;if A is 1, 'win' is defined as below the sprite
;returns A as 1 if our sprite wins
;
;;;;;;;;;

LocateContact:
PHA		;preserve win settings
LDA $14D4,y	;\set enemy ypos to scratch
STA $01		; |
LDA $00D8,y	; |
STA $00		;/
LDA $14D4,x	;\get self ypos to scratch
STA $03
LDA $D8,x	; 
STA $02
PLA
BNE casebottom
REP #$20
LDA $02
CLC
ADC #$0004
SEC
CMP $00		;carry clear = on top
BCC ontop
SEP #$20
LDA #$00
RTS
ontop:
SEP #$20
LDA #$01
RTS
casebottom:
REP #$20
LDA $02
SEC
SBC #$000C
SEP #$20
CLC
CMP $00		;carry set = below
BCS onbottom
LDA #$00
RTS
onbottom:
LDA #$01
RTS	

;;;;;;;;;
;
; BoostSpeed
;
; Boost's Luigi's speed as though he stomped on an enemy.
;;;;;;;;;

BoostSpeed:
;PHX
;TYX
JSL $01AB6F
;PLX
LDA $0DA3
ORA $0DA5
BIT #$80
BNE LargeJump
LDA #$E0
STA $AA,x
RTS
LargeJump:
LDA #$C0
STA $AA,x
RTS

;;;;;;;;;
;
; AddToYpos
;
; Adds a 16-bit value to spirite ypos
;;;;;;;;;

AddToYpos:
REP #$20
PHA
SEP #$20
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
STA $04
PLA
CLC
ADC $04
SEP #$20
STA $D8,x
XBA
STA $14D4,x
RTS

;;;;;;;;
;
; ProcessCarryableItem
;
; return: --LBSKTN
;;;;;;;;

ProcessCarryableItem:
LDA $14C8,y
CMP #$09
BEQ StunCQ
CMP #$0A
BEQ KickCQ
LDA #$09
RTS
StunCQ:
LDA $0670,y
BNE CheckSelfCarry
LDA $0DA3
ORA $0DA5
BIT #$40
BNE StunBP
LDA #$11
RTS
StunBP:
LDA #$01
STA $0670,y
LDA #$00
RTS
KickCQ:
LDA #$00
JSR LocateContact
CLC
ASL
ORA #$05
STA $06
LDA $0DA3
ORA $0DA5
AND #$40
EOR #$40
LSR
LSR
ORA $06
RTS
CheckSelfCarry:
LDA $0DA3
ORA $0DA5
BIT #$40
BEQ LetGo
UpdatePosByCarry:
LDA $151C,x
BNE HoldLeft
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC #$000A
BRA EndHoldDir
HoldLeft:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
CLC
ADC #$000A
EndHoldDir:
SEP #$20
STA $00E4,y
XBA
STA $14E0,y
REP #$20
LDA #$FFFF
JSR AddToYpos
LDA $14D4,x
STA $14D4,y
LDA $D8,x
STA $00D8,y
REP #$20
LDA #$0001
JSR AddToYpos
LDA #$00
RTS
LetGo:
LDA $14E0,x
STA $14E0,y
LDA $E4,x
STA $00E4,y
LDA #$00
STA $0670,y
LDA $0DA3
BIT #$08
BNE TossUp
BIT #$04
BNE DropDown
LDA $151C,x
BEQ KickLeft
KickRight:
LDA #$40
STA $00B6,y
LDA #$0A
STA $14C8,y
LDA #$12
STA $1DF9
LDA #$00
RTS
KickLeft:
LDA #$C0
STA $00B6,y
LDA #$0A
STA $14C8,y
LDA #$11
STA $1DF9
LDA #$00
RTS
DropDown:
LDA $B6,x
STA $00B6,y
LDA #$09
STA $14C8,y
LDA #$00
RTS
TossUp:
LDA $B6,x
STA $00B6,y
LDA #$80
STA $00AA,y
LDA #$13
STA $1DF9
LDA #$09
STA $14C8,y
LDA #$00
RTS

SpinKillSprite:
LDX $15E9
JSL $01AB6F
PHX
TYX
STY $15E9
JSL $07FC3B
TXY
PLX
STX $15E9
STZ $AA,x
LDA #$04
STA $14C8,y
LDA #$08
STA $1DF9
LDA #$18
STA $1540,y
RTS

KillWithStar:
LDA $1DFC
PHA
PHY
LDY #$00
JSR SpinKillEntry
PLY
PLA
STA $1DFC
LDA #$02
STA $14C8,y
LDA $1658,y
BIT #$80
BEQ FallDown
LDA #$03
STA $14C8,y
LDA #$20
STA $1540,y
FallDown:
LDA #$D0
STA $00AA,y
STA $00B6,y
PHY
JSR ADDR_02D4FA
CPY #$00
BEQ KillStarEnd
PLY
LDA #$30
STA $00B6,y
RTS
KillStarEnd:
PLY
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; BounceSquash
;
; Squashes a sprite by bouncing on it
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BounceSquash:
STA $14C8,y
JSR BoostSpeed
PHY

LDY #$00
SpinKillEntry:
LDA $06A3,y
INC
STA $06A3,y
CMP #$08
BCC NoNeedPanicSquash
LDA #$02
STA $1DF9
LDA #$08
STA $06A3,y
JMP OneUpRex
NoNeedPanicSquash:
LDA $06A3
CLC
ADC #$46
STA $1DFC
LDA $06A3,y
PLY
PHY
PHX
TYX
JSL $02ACE5
PLX
PLY
RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; SPRITE_INTERACT
;
; Oh, lovely, I get to code interaction with EVERY SINGLE ****ING SPRITE IN THE GAME
; :(
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_INTERACT:
PHX			;preserve x - NEEDS TO BE BE PULLED IN EACH ROUTINE
TYX
LDA $9E,x		;\client sprite #
REP #$30		; |set 16 bit a + xy
AND #$00FF		; |clear high byte
ASL			; |shift left
TAX			; |send to X
SEP #$20		; |8 bit a -- NOT XY - NEED TO SEP #$10 FIRST
JMP (Ptr,x)		;/Jump to interaction routine

Ptr:
DW Sprite00
DW Sprite00
DW Sprite00
DW Sprite00
DW Sprite04
DW Sprite04
DW Sprite04
DW Sprite04
DW Sprite08
DW Sprite09
DW Sprite0A
DW Sprite0B
DW Sprite0C
DW Sprite0D
DW Sprite0E
DW Sprite0F
DW Sprite10
DW Sprite11
DW Sprite12
DW Sprite41
DW Sprite41
DW Sprite15
DW Sprite16
DW Sprite17
DW Sprite18
DW Sprite19
DW Sprite4F
DW Sprite1B
DW Sprite1C
DW Sprite41
DW Sprite1E
DW Sprite1F 
DW Sprite4F
DW Sprite21
DW Sprite22
DW Sprite23
DW Sprite24
DW Sprite25
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite29
DW Sprite2A
DW Sprite2B
DW Sprite2C
DW Sprite2D
DW Sprite4F
DW Sprite2F 
DW Sprite30
DW Sprite31
DW Sprite32
DW Sprite4F
DW Sprite4F
DW Sprite35
DW Sprite36
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite3E
DW Sprite3F 
DW Sprite40
DW Sprite41
DW Sprite42
DW Sprite43
DW Sprite44
DW Sprite45
DW Sprite91
DW Sprite4F
DW Sprite48
DW Sprite49
DW Sprite4A
DW Sprite4B
DW Sprite4C
DW Sprite4D
DW Sprite4E
DW Sprite4F 
DW Sprite4F
DW Sprite51
DW Sprite52
DW Sprite53
DW Sprite54
DW Sprite55
DW Sprite56
DW Sprite57
DW Sprite58
DW Sprite59
DW Sprite5A
DW Sprite5B
DW Sprite5C
DW Sprite5D
DW Sprite5E
DW Sprite5F 
DW Sprite60
DW Sprite61
DW Sprite62
DW Sprite63
DW Sprite64
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite69
DW Sprite6A
DW Sprite6B
DW Sprite6C
DW Sprite6D
DW Sprite6E
DW Sprite6F 
DW Sprite4F
DW Sprite71
DW Sprite72
DW Sprite73
DW Sprite74
DW Sprite75
DW Sprite76
DW Sprite77
DW Sprite78
DW Sprite79
DW Sprite7A
DW Sprite7B
DW Sprite7C
DW Sprite7D
DW Sprite7E
DW Sprite78
DW Sprite80
DW Sprite81
DW Sprite82
DW Sprite83
DW Sprite84
DW Sprite85
DW Sprite86
DW Sprite87
DW Sprite88
DW Sprite89
DW Sprite8A
DW Sprite8B
DW Sprite8C
DW Sprite8D
DW Sprite8E
DW Sprite8F 
DW Sprite90
DW Sprite91
DW Sprite91
DW Sprite91
DW Sprite91
DW Sprite91
DW Sprite91
DW Sprite91
DW Sprite91
DW Sprite4F
DW Sprite4F
DW Sprite9B
DW Sprite9C
DW Sprite9D
DW Sprite4F
DW Sprite9F 
DW SpriteA0
DW SpriteA1
DW SpriteA2
DW SpriteA3
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW SpriteAB
DW SpriteAC
DW SpriteAD
DW SpriteAE
DW SpriteAF 
DW SpriteB0
DW SpriteB1
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW Sprite4F
DW SpriteB7
DW SpriteB8
DW SpriteB9
DW SpriteBA
DW SpriteBB
DW SpriteBC
DW Sprite00
DW SpriteBE
DW SpriteBF 
DW SpriteC0
DW SpriteC1
DW Sprite4F
DW Sprite4F
DW SpriteC4
DW SpriteC5
DW SpriteC6
DW SpriteC7
DW SpriteC8
DW SpriteC9
DW SpriteCA



Sprite00:		;Shelless green koopa and others
SEP #$10
PLX
LDA $1570,x
BEQ $03
JMP KillWithStar
KoopaRoutine:
LDA $14C8,y
CMP #$08
BNE Gturn
LDA #$00
JSR LocateContact
BEQ GreenWins
LDA $06A0
AND #$01
BNE GreenSpinKill
LDA #$03
JSR BounceSquash
LDA #$18
STA $1540,y
Gturn:
RTS
GreenSpinKill:
JSR SpinKillSprite
RTS
GreenWins:
JSR HurtLuigi
RTS

			;Red shelless koopa = green shelless koopa

			;blue shelless koopa = green shelless koopa

			;yellow shelless koopa = green shelless koopa

GKoopaWins:
JSR HurtLuigi
RTS

Sprite04:		;green koopa
SEP #$10
PLX
LDA $1570,x
BEQ $03
JMP KillWithStar
LDA $14C8,y
CMP #$09
BNE GKoopaReg
akakaka:
JMP GKoopaShell
GKoopaReg:
CMP #$04
BEQ akakaka
LDA #$00
JSR LocateContact
BEQ GKoopaWins
LDA $06A0
BIT #$01
BEQ Labelname8
JMP SpinKillGreenKoopa
Labelname8:
LDA $14C8,y
CMP #$0A
BNE Labelname9
JMP KickedShellG
Labelname9:
LDA #$00
STA $00B6,y
REP #$20
LDA #$FFFC
JSR AddToYpos

STX $0F
TYX

JSL $02A9DE		;\Get sprite slot to y
BPL GKoopaGo		;/if none, return
RTS
GKoopaGo:
LDA #$08                ; \ Sprite status = Normal 
STA $14C8,Y             ; / 
PHX
LDA $9E,X       	; \ Store sprite number for shelless koopa 
TAX                     ;  | 
LDA $01961C,X 		;  | 
STA $009E,Y     	; / 
TYX                     ; \ Reset sprite tables 
JSL $07F7D2    		;  | 
PLX	                ; / 
LDA $E4,X       	; \ Shelless Koopa position = Koopa position 
STA $00E4,Y     	;  | 
LDA $14E0,X     	;  | 
STA $14E0,Y     	;  | 
LDA $D8,X       	;  | 
STA $00D8,Y     	;  | 
LDA $14D4,X     	;  | 
STA $14D4,Y     	; / 
LDA #$00                ; \ Direction = 0 
STA $157C,Y     	; / 
LDA #$10                
STA $1564,Y             
LDA $164A,X             
STA $164A,Y             
STZ $1540,X
PHX
PHY                       
JSR ADDR_02D4FA         ; \ Find sprite's position relative to mario
TYX
LDA $0197AD,x       ;  |Load speed based on that
STY $00                   ; / Store index to scratch
PLY                       
PLX
STA $00B6,Y  ;   set speed
LDA $00                   ; \
EOR #$01                ;  | 
STA $157C,Y     ;  |set direction
STA $01                   ; / and set to scratch
LDA #$10                ; \ disable interaction for ten frames
STA $1528,Y  ; /
STA $1528,Y             
LDA $9E,X       ; \ If Yellow Koopa... 
CMP #$07                ;  | 
BNE Labelname7          ;  | 
LDY #$08                ;  | ...find free sprite slot...
MCLoop: 
LDA $14C8,Y             ;  | 
BEQ SpawnMovingCoin       ;  | ...and spawn moving coin 
DEY                       ;  | 
BPL MCLoop           ; / 
Labelname7:
TXY
LDX $0F
LDA #$00
STA $00B6,y

KickedShellG:
LDA #$09
STA $14C8,y
JSR BoostSpeed
LDA #$13
STA $1DF9
RTS

SpawnMovingCoin:
LDA #$08                ; \ Sprite status = normal 
STA $14C8,Y             ; / 
LDA #$21                ; \ Sprite = Moving Coin 
STA $009E,Y     ; / 
LDA $E4,X       ; \ Copy X position to coin 
STA $00E4,Y     ;  | 
LDA $14E0,X     ;  | 
STA $14E0,Y     ; / 
LDA $D8,X       ; \ Copy Y position to coin 
STA $00D8,Y     ;  | 
LDA $14D4,X     ;  | 
STA $14D4,Y     ; / 
PHX                       ; \ 
TYX                       ;  | 
JSL $07F7D2    ;  | Clear all sprite tables, and load new values 
PLX                       ; / 
LDA #$D0                ; \ Set Y speed 
STA $00AA,Y  ; / 
LDA $01                   ; \ Set direction 
STA $157C,Y     ; / 
LDA #$20                
STA $154C,Y  
BRA Labelname7

SpinKillGreenKoopa:
JSR SpinKillSprite
RTS

GKoopaShell:
LDA $06A0
BIT #$01
BEQ NoSpinGShell
LDA #$00
JSR LocateContact
BNE SpinKillGreenKoopa
NoSpinGShell:
LDA $0DA3
ORA $0DA5
BIT #$40
BEQ NoXYGK
JSR UpdatePosByCarry
LDA #$01
STA $0670,y
RTS
NoXYGK:
LDA $0670,y
BEQ KickGShellLR
LDA #$00
STA $0670,y
JSR LetGo
RTS
KickGShellLR:
PHX
TYX
JSR ADDR_02D4FA
LDA LaunchShellSpeeds,y
STA $B6,x
TXY
PLX
RTS

GKoopaReturn:
RTS

LaunchKoopaSpeeds:
db $20,$E0
LaunchShellSpeeds:
db $30,$D0

			;other koopas = green koopa

Sprite08:
SEP #$10
PLX
RTS

Sprite09:
SEP #$10
PLX
RTS

Sprite0A:
SEP #$10
PLX
RTS

Sprite0B:
SEP #$10
PLX
RTS

Sprite0C:
SEP #$10
PLX
RTS

Sprite0D:
SEP #$10
PLX
RTS

Sprite0E:
SEP #$10
PLX
RTS

Sprite0F:
SEP #$10
PLX
RTS

Sprite10:
SEP #$10
PLX
RTS

Sprite11:
SEP #$10
PLX
RTS

Sprite12:
SEP #$10
PLX
RTS

Sprite15:
SEP #$10
PLX
RTS

Sprite16:
RTS

Sprite17:
RTS

Sprite18:
RTS

Sprite19:
RTS

Sprite1B:
RTS

Sprite1C:
RTS

Sprite1E:
RTS

Sprite1F:
RTS

Sprite20:
RTS

Sprite21:
SEP #$10
PLX
LDA $0DBF
CMP #$63
BEQ NoGiveCoin
INC $0DBF
NoGiveCoin:
LDA #$01
STA $1DFC
LDA #$00
STA $14C8,y
RTS

Sprite22:
RTS

Sprite23:
RTS

Sprite24:
RTS

Sprite25:
RTS

			;thwonp + thwimp = jumping piranah

Sprite28:
RTS

Sprite29:
RTS

Sprite2A:		;upside down piranah plant
SEP #$10
PLX
LDA $1570,x
BEQ $03
JMP KillWithStar
JSL HurtLuigi
RTS

Sprite2B:
RTS

Sprite2C:
RTS

Sprite2D:
RTS

Sprite2E:
RTS

Sprite2F:
SEP #$10
PLX
RTS

Sprite30:
RTS

Sprite31:
RTS

Sprite32:
RTS

			;jumping + boss fireballs = jumping pirranah

Sprite35:
RTS

Sprite36:
RTS

Sprite37:
RTS

Sprite38:
RTS

Sprite39:
RTS

Sprite3A:
RTS

Sprite3B:
RTS

Sprite3C:
RTS

Sprite3D:
RTS

Sprite3E:			;P-switch
SEP #$10
PLX
JSR ProcessCarryableItem
BEQ Pdone
BIT #$10
BNE NoCarryP
LDA #$01
STA $0670,y
Pdone:
RTS
NoCarryP:
LDA #$00
JSR LocateContact
BNE PressP
STZ $B6,x
RTS
PressP:
LDA #$03
STA $14C8,y
LDA #$20
STA $1540,y
LDA #$0B
STA $1DF9
LDA #$0E
STA $1DFB
STZ $AA,x
LDA $151C,y
BNE SilverP
LDA #$FF
STA $14AD
RTS
SilverP:
LDA #$FF
STA $14AE
RTS
RTS

Sprite3F:
RTS

Sprite40:
RTS

Sprite41:
RTS

Sprite42:
RTS

Sprite43:
RTS

Sprite44:
RTS

Sprite45:
RTS

			;diggin' chuck = chargin' chuck

			;diggin' chuck's rock = jumping pirannah

Sprite48:
RTS

Sprite49:
RTS

Sprite4A:
RTS

Sprite4B:
RTS

Sprite4C:
RTS

Sprite4D:
RTS

Sprite4E:
RTS

Sprite4F:		;Jumping Pirannah
SEP #$10
PLX
LDA $1570,x
BEQ $03
JMP KillWithStar
LDA $06A0
AND #$01
BNE CheckContactJP
LloseJP:
JSR HurtLuigi
RTS
CheckContactJP:
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
SEC
SBC #$0004
SEP #$20
STA $D8,x
XBA
STA $14D4,x
LDA #$00
JSR LocateContact
PHA
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
CLC
ADC #$0004
SEP #$20
STA $D8,x
XBA
STA $14D4,x
PLA
BEQ LloseJP
JSR BoostSpeed
LDA #$02
STA $1DF9
RTS

			;SpitFire Jumping Pirannah = Jumping pirannah

Sprite51:
RTS

Sprite52:
RTS

Sprite53:
RTS

Sprite54:
RTS

Sprite55:
RTS

Sprite56:
RTS

Sprite57:
RTS

Sprite58:
RTS

Sprite59:
RTS

Sprite5A:
RTS

Sprite5B:
RTS

Sprite5C:
RTS

Sprite5D:
RTS

Sprite5E:
RTS

Sprite5F:
RTS

Sprite60:
RTS

Sprite61:
RTS

Sprite62:
RTS

Sprite63:
RTS

Sprite64:
RTS

Sprite68:
RTS

Sprite69:
RTS

Sprite6A:
RTS

Sprite6B:
RTS

Sprite6C:
RTS

Sprite6D:
RTS

Sprite6E:
RTS

Sprite6F:
RTS

Sprite70:
RTS

Sprite71:
RTS

Sprite72:
RTS

Sprite73:
RTS

Sprite74:		;Mushroom
SEP #$10
PLX
LDA #$00
STA $14C8,y
LDA #$0A
STA $1DF9
LDA $06A0
AND #$18
BNE MushReturn
LDA $06A0
ORA #$08
STA $06A0
LDA #$40
STA $9D
STA $1540,x
MushReturn:
RTS

Sprite75:		;Flower
SEP #$10
PLX
LDA #$00
STA $14C8,y
LDA $06A0
ORA #$18
STA $06A0
LDA #$0A
STA $1DF9
RTS

Sprite76:		;star
SEP #$10
PLX
LDA #$00
STA $14C8,y
LDA #$FF
STA $1570,x
LDA $0DDA
STA $1534,x
LDA #$0A
STA $1DF9
LDA #$0D
STA $1DFB
RTS

Sprite77:		;feather
SEP #$10
PLX
LDA #$00
STA $14C8,y
LDA #$0D
STA $1DF9
RTS

Sprite78:		;1-up
SEP #$10
PLX
LDA #$00
STA $14C8,y
OneUpRex:
LDA $0DBE
PHA
LDA #$08
PHX
TYX
JSL $02ACE5
TXY
PLX
PLA
CMP #$63
BEQ NoMarioLiveDec
DEC
STA $0DBE
NoMarioLiveDec:
LDA $06A1
CMP #$63
BEQ NoRexLiveInc
INC $06A1
NoRexLiveInc:
RTS

Sprite79:		;growing vine
SEP #$10
PLX
RTS

Sprite7A:
RTS

Sprite7B:		;goal
SEP #$10
PLX
RTS

Sprite7C:
RTS

Sprite7D:
RTS

Sprite7E:
RTS

			;flying yellow mushroom = 1up

Sprite80:
RTS

Sprite81:		;changing item
SEP #$10
LDA $187B,y               ; \ Determine which power-up to act like 
LSR                       ;  | 
LSR                       ;  | 
LSR                       ;  | 
LSR                       ;  | 
LSR                       ;  | 
LSR                       ;  | 
AND #$03                  ;  | 
ASL			  ;  |
TAX                       ;  |
JMP (ChangingItem,x)	  ; /

ChangingItem:
dw Sprite74
dw Sprite75
dw Sprite77
dw Sprite76

Sprite82:
RTS

Sprite83:
RTS

Sprite84:
RTS

Sprite85:
RTS

Sprite86:
RTS

Sprite87:
RTS

Sprite88:
RTS

Sprite89:
RTS

Sprite8A:
RTS

Sprite8B:
RTS

Sprite8C:
RTS

Sprite8D:
RTS

Sprite8E:
RTS

Sprite8F:
RTS

Sprite90:
RTS

Sprite91:		;chargin' chuck
SEP #$10
PLX
LDA $1570,x
BEQ $03
JMP KillWithStar
LDA #$00
JSR LocateContact	;\if the chuck wins
BEQ ChuckWins		;/hurt player
JSR BoostSpeed
LDA #$02		;\bounce sound
STA $1DF9		;/
LDA $00C2,y		;\if stunned
CMP #$03		; |
BEQ ChuckBounce		;/don't hurt
LDA $1528,y		;\inc hitpoints
INC			; |
STA $1528,y		;/
CMP #$03		;\if three, kill
BEQ KillChuck		;/

LDA #$28                ;\ Play sound effect ;From chuck dissasembly
STA $1DFC               ;/ 
LDA #$03                
STA $00C2,y		
STA $1540,y
LDA #$00		
STA $1570,y		
PHY
JSR ADDR_02D4FA         
LDA ChuckBounceXsp,Y    
PLY   
STA $00B6,x
RTS

KillChuck:
LDA #$02
STA $14C8,y
LDA #$13
STA $1DF9
ChuckBounce:
RTS

ChuckWins:
JSR HurtLuigi
RTS

ChuckBounceXsp:
db $20,$E0

ADDR_02D4FA:       
LDA $E4,x                   
SEC                       
SBC $00E4,y                 
STA $0F                   ;return sprite's xpos reletive to mario
LDA $14E0,x                   
SBC $14E0,y        
PHP
LDY #$00
PLP     
BPL Return02D50B          
INY                       ;return y as 1 if player on left of enemy
Return02D50B:
RTS

			;ALL CHUCKS = chargin' chuck

Sprite99:
RTS

Sprite9A:
RTS

Sprite9B:
RTS

Sprite9C:
RTS

Sprite9D:
RTS

Sprite9F:		;Banzai bill
SEP #$10
PLX
LDA $1570,x
BEQ $03
JMP KillWithStar
REP #$20
LDA #$FFF0
JSR AddToYpos
LDA #$00
JSR LocateContact
PHA
REP #$20
LDA #$0010
JSR AddToYpos
PLA
BEQ BanzaiWin
LDA $06A0
AND #$01
BNE BanzaiSpinKill
;JSL $01AB99
LDA #$02
STA $14C8,y
LDA #$00
STA $00AA,y
STA $00B6,y
LDA #$13
STA $1DF9
JSR BoostSpeed
RTS
BanzaiSpinKill:
JSR SpinKillSprite
RTS
BanzaiWin:
JSR HurtLuigi
RTS

SpriteA0:
RTS

SpriteA1:
RTS

SpriteA2:
RTS

SpriteA3:
RTS

SpriteAA:
RTS

SpriteAB:		;Rex
SEP #$10
PLX
LDA $1570,x
BEQ $03
JMP KillWithStar
LDA $1FE2,y
ORA $1558,y
BNE RexEnd
LDA #$00
JSR LocateContact
BEQ RexWins
LDA $06A0
AND #$01
BNE RexSpinKill
PHX
TYX
INC $C2,x
PLX
LDA $00C2,y
CMP #$02
BNE SmushRex
JSR BoostSpeed
LDA #$13
STA $1DF9
LDA #$20
STA $1558,y
RexEnd:
RTS
SmushRex:
LDA #$0C                ; \ Time to show semi-squashed Rex = $0C 
STA $1FE2,y             ; /	
LDA #$00				     
STA $1662,y  		; Change clipping area for squashed Rex
JSR BoostSpeed
LDA #$13
STA $1DF9
RTS
RexSpinKill:
JSR SpinKillSprite
JSR BoostSpeed
LDA #$08
STA $1DF9
STZ $1DFC
RTS
RexWins:
JSR HurtLuigi
RTS

SpriteAC:
RTS

SpriteAD:
RTS

SpriteAE:
RTS

SpriteAF:
RTS

SpriteB0:
RTS

SpriteB1:
RTS

SpriteB7:
RTS

SpriteB8:
RTS

SpriteB9:		;Message Box
SEP #$10
PLX
LDA #$01
JSR LocateContact
BNE PlayMessage
JSR LocateContact
BNE StandOnMessage
STZ $B6,x
RTS
PlayMessage:
LDA #$01
STA $1DF9
LDA #$22
STA $1DFC
LDA $00D8,y
LSR
LSR
LSR
LSR
AND #$01
INC
STA $1426
LDA #$30
STA $AA,x
RTS
StandOnMessage:
LDA $1588,x		;Set standing on ground flag
ORA #$04
STA $1588,x
TYA
INC
;STA $157C,x
LDA $00D8,y
STA $D8,x
LDA $14D4,y
STA $14D4,x
LDA $00AA,y
STA $AA,x
MessEnd:
RTS

SpriteBA:
RTS

SpriteBB:
RTS

SpriteBC:
RTS

			;blue sliding koopa = green shelless koopa

SpriteBE:
RTS

SpriteBF:
RTS

SpriteC0:
RTS

SpriteC1:
RTS

SpriteC4:
RTS

SpriteC5:
RTS

SpriteC6:
RTS

SpriteC7:		;Invisible mushroom
SEP #$10
TYX
PLY
JSL GenMushroom
PHY
TXY
PLX
RTS

SpriteC8:
RTS

SpriteC9:
RTS

SpriteCA:
RTS

Map16Setup:
LDA $00                   
AND #$F0                
STA $06                   
LDA $02                   
LSR                       
LSR                       
LSR                       
LSR                                              
ORA $06                   
PHA                      
LDA $5A     
AND #$01                
BEQ .label1          
PLA                       
LDX $01                   
CLC                       
ADC $00BA80,X       
STA $05                   
LDA $00BABC,X       
ADC $03                   
STA $06                   
BRA .label2          

.label1
PLA                       
LDX $03                   
CLC                       
ADC.l $00BA60,X       
STA $05                   
LDA.l $00BA9C,x       
ADC $01                   
STA $06                   

.label2
LDA.b #$7E                
STA $07                   
LDX $15E9
RTS

PositionSetup:
LDA $06A0
LSR #3
AND #$03
STA $04
LSR
ORA $04
AND #$01
ASL #4
CLC
ADC #$10
STA $04		;$04 is now height

LDA $E4,x
STA $60
LDA $14E0,x
STA $61
LDA $D8,x
STA $62
LDA $14D4,x
STA $63		;$60/$62 now have x/y positions

REP #$20
LDA $00
CLC
ADC #$000E
CMP $62
BCS .NotBelow	;if this doesn't branch, you're on the bottom
SEP #$20
STZ $04
RTS
.NotBelow
SEP #$20
LDA #$00
XBA
LDA $04
REP #$20
EOR #$FFFF
INC
CLC
ADC $62
SEC
SBC #$0002
CMP $00
BCC .NotTop	;if this doesn't branch, you're on the top
SEP #$20
LDA #$01
STA $04
RTS
.NotTop
LDA $60
CMP $02
BCS .OnRight	;if this doesn't branch, you're on the left
SEP #$20
LDA #$02
STA $04
RTS
.OnRight
SEP #$20
LDA #$03
STA $04
RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; BLOCK_SETUP and BLOCK_INTERACT
;
; setup will determine which block you're touching and how you're touching it, then call interact.
; interact is a lot like Sprite_Interact.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Block_Setup:
JSR Map16Setup		;Enable LDA [$05]
JSR PositionSetup	;set $04 to way you're touching it
PHX
JSR Block_Interact	;interact
PLX
RTS

Block_Interact:
;LDA $1337
INC $07
LDA [$05]
XBA
DEC $07
LDA [$05]
REP #$30
ASL
TAY
LDA BlockTable,y
STA $0DC4
SEP #$30
JMP ($0DC4)

BlockTable:

dw Block0
dw Block1
dw Block2
dw Block3
dw Block4
dw Block5
dw Block6
dw Block7
dw Block8
dw Block9
dw BlockA
dw BlockB
dw BlockC
dw BlockD
dw BlockE
dw BlockF
dw Block10
dw Block11
dw Block12
dw Block13
dw Block14
dw Block15
dw Block16
dw Block17
dw Block18
dw Block19
dw Block1A
dw Block1B
dw Block1C
dw Block1D
dw Block1E
dw Block1F
dw Block20
dw Block21
dw Block22
dw Block23
dw Block24
dw Block25
dw Block26
dw Block27
dw Block28
dw Block29
dw Block2A
dw Block2B
dw Block2C
dw Block2D
dw Block2E
dw Block2F
dw Block30
dw Block31
dw Block32
dw Block33
dw Block34
dw Block35
dw Block36
dw Block37
dw Block38
dw Block39
dw Block3A
dw Block3B
dw Block3C
dw Block3D
dw Block3E
dw Block3F
dw Block40
dw Block41
dw Block42
dw Block43
dw Block44
dw Block45
dw Block46
dw Block47
dw Block48
dw Block49
dw Block4A
dw Block4B
dw Block4C
dw Block4D
dw Block4E
dw Block4F
dw Block50
dw Block51
dw Block52
dw Block53
dw Block54
dw Block55
dw Block56
dw Block57
dw Block58
dw Block59
dw Block5A
dw Block5B
dw Block5C
dw Block5D
dw Block5E
dw Block5F
dw Block60
dw Block61
dw Block62
dw Block63
dw Block64
dw Block65
dw Block66
dw Block67
dw Block68
dw Block69
dw Block6A
dw Block6B
dw Block6C
dw Block6D
dw Block6E
dw Block6F
dw Block70
dw Block71
dw Block72
dw Block73
dw Block74
dw Block75
dw Block76
dw Block77
dw Block78
dw Block79
dw Block7A
dw Block7B
dw Block7C
dw Block7D
dw Block7E
dw Block7F
dw Block80
dw Block81
dw Block82
dw Block83
dw Block84
dw Block85
dw Block86
dw Block87
dw Block88
dw Block89
dw Block8A
dw Block8B
dw Block8C
dw Block8D
dw Block8E
dw Block8F
dw Block90
dw Block91
dw Block92
dw Block93
dw Block94
dw Block95
dw Block96
dw Block97
dw Block98
dw Block99
dw Block9A
dw Block9B
dw Block9C
dw Block9D
dw Block9E
dw Block9F
dw BlockA0
dw BlockA1
dw BlockA2
dw BlockA3
dw BlockA4
dw BlockA5
dw BlockA6
dw BlockA7
dw BlockA8
dw BlockA9
dw BlockAA
dw BlockAB
dw BlockAC
dw BlockAD
dw BlockAE
dw BlockAF
dw BlockB0
dw BlockB1
dw BlockB2
dw BlockB3
dw BlockB4
dw BlockB5
dw BlockB6
dw BlockB7
dw BlockB8
dw BlockB9
dw BlockBA
dw BlockBB
dw BlockBC
dw BlockBD
dw BlockBE
dw BlockBF
dw BlockC0
dw BlockC1
dw BlockC2
dw BlockC3
dw BlockC4
dw BlockC5
dw BlockC6
dw BlockC7
dw BlockC8
dw BlockC9
dw BlockCA
dw BlockCB
dw BlockCC
dw BlockCD
dw BlockCE
dw BlockCF
dw BlockD0
dw BlockD1
dw BlockD2
dw BlockD3
dw BlockD4
dw BlockD5
dw BlockD6
dw BlockD7
dw BlockD8
dw BlockD9
dw BlockDA
dw BlockDB
dw BlockDC
dw BlockDD
dw BlockDE
dw BlockDF
dw BlockE0
dw BlockE1
dw BlockE2
dw BlockE3
dw BlockE4
dw BlockE5
dw BlockE6
dw BlockE7
dw BlockE8
dw BlockE9
dw BlockEA
dw BlockEB
dw BlockEC
dw BlockED
dw BlockEE
dw BlockEF
dw BlockF0
dw BlockF1
dw BlockF2
dw BlockF3
dw BlockF4
dw BlockF5
dw BlockF6
dw BlockF7
dw BlockF8
dw BlockF9
dw BlockFA
dw BlockFB
dw BlockFC
dw BlockFD
dw BlockFE
dw BlockFF
dw Block100
dw Block101
dw Block102
dw Block103
dw Block104
dw Block105
dw Block106
dw Block107
dw Block108
dw Block109
dw Block10A
dw Block10B
dw Block10C
dw Block10D
dw Block10E
dw Block10F
dw Block110
dw Block111
dw Block112
dw Block113
dw Block114
dw Block115
dw Block116
dw Block117
dw Block118
dw Block119
dw Block11A
dw Block11B
dw Block11C
dw Block11D
dw Block11E
dw Block11F
dw Block120
dw Block121
dw Block122
dw Block123
dw Block124
dw Block125
dw Block126
dw Block127
dw Block128
dw Block129
dw Block12A
dw Block12B
dw Block12C
dw Block12D
dw Block12E
dw Block12F
dw Block130
dw Block131
dw Block132
dw Block133
dw Block134
dw Block135
dw Block136
dw Block137
dw Block138
dw Block139
dw Block13A
dw Block13B
dw Block13C
dw Block13D
dw Block13E
dw Block13F
dw Block140
dw Block141
dw Block142
dw Block143
dw Block144
dw Block145
dw Block146
dw Block147
dw Block148
dw Block149
dw Block14A
dw Block14B
dw Block14C
dw Block14D
dw Block14E
dw Block14F
dw Block150
dw Block151
dw Block152
dw Block153
dw Block154
dw Block155
dw Block156
dw Block157
dw Block158
dw Block159
dw Block15A
dw Block15B
dw Block15C
dw Block15D
dw Block15E
dw Block15F
dw Block160
dw Block161
dw Block162
dw Block163
dw Block164
dw Block165
dw Block166
dw Block167
dw Block168
dw Block169
dw Block16A
dw Block16B
dw Block16C
dw Block16D
dw Block16E
dw Block16F
dw Block170
dw Block171
dw Block172
dw Block173
dw Block174
dw Block175
dw Block176
dw Block177
dw Block178
dw Block179
dw Block17A
dw Block17B
dw Block17C
dw Block17D
dw Block17E
dw Block17F
dw Block180
dw Block181
dw Block182
dw Block183
dw Block184
dw Block185
dw Block186
dw Block187
dw Block188
dw Block189
dw Block18A
dw Block18B
dw Block18C
dw Block18D
dw Block18E
dw Block18F
dw Block190
dw Block191
dw Block192
dw Block193
dw Block194
dw Block195
dw Block196
dw Block197
dw Block198
dw Block199
dw Block19A
dw Block19B
dw Block19C
dw Block19D
dw Block19E
dw Block19F
dw Block1A0
dw Block1A1
dw Block1A2
dw Block1A3
dw Block1A4
dw Block1A5
dw Block1A6
dw Block1A7
dw Block1A8
dw Block1A9
dw Block1AA
dw Block1AB
dw Block1AC
dw Block1AD
dw Block1AE
dw Block1AF
dw Block1B0
dw Block1B1
dw Block1B2
dw Block1B3
dw Block1B4
dw Block1B5
dw Block1B6
dw Block1B7
dw Block1B8
dw Block1B9
dw Block1BA
dw Block1BB
dw Block1BC
dw Block1BD
dw Block1BE
dw Block1BF
dw Block1C0
dw Block1C1
dw Block1C2
dw Block1C3
dw Block1C4
dw Block1C5
dw Block1C6
dw Block1C7
dw Block1C8
dw Block1C9
dw Block1CA
dw Block1CB
dw Block1CC
dw Block1CD
dw Block1CE
dw Block1CF
dw Block1D0
dw Block1D1
dw Block1D2
dw Block1D3
dw Block1D4
dw Block1D5
dw Block1D6
dw Block1D7
dw Block1D8
dw Block1D9
dw Block1DA
dw Block1DB
dw Block1DC
dw Block1DD
dw Block1DE
dw Block1DF
dw Block1E0
dw Block1E1
dw Block1E2
dw Block1E3
dw Block1E4
dw Block1E5
dw Block1E6
dw Block1E7
dw Block1E8
dw Block1E9
dw Block1EA
dw Block1EB
dw Block1EC
dw Block1ED
dw Block1EE
dw Block1EF
dw Block1F0
dw Block1F1
dw Block1F2
dw Block1F3
dw Block1F4
dw Block1F5
dw Block1F6
dw Block1F7
dw Block1F8
dw Block1F9
dw Block1FA
dw Block1FB
dw Block1FC
dw Block1FD
dw Block1FE
dw Block1FF


Block0:
Block1:
Block2:
Block3:
Block4:
Block5:
Block6:
Block7:
Block8:
Block9:
BlockA:
BlockB:
BlockC:
BlockD:
BlockE:
BlockF:
Block10:
Block11:
Block12:
Block13:
Block14:
Block15:
Block16:
Block17:
Block18:
Block19:
Block1A:
Block1B:
Block1C:
Block1D:
Block1E:
Block1F:
Block20:
Block21:
Block22:
Block23:
Block24:
Block25:
Block26:
Block27:
Block28:
Block29:
Block2A:
Block2B:
Block2C:
Block2D:
Block2E:
Block2F:
Block30:
Block31:
Block32:
Block33:
Block34:
Block35:
Block36:
Block37:
Block38:
Block39:
Block3A:
Block3B:
Block3C:
Block3D:
Block3E:
Block3F:
Block40:
Block41:
Block42:
Block43:
Block44:
Block45:
Block46:
Block47:
Block48:
Block49:
Block4A:
Block4B:
Block4C:
Block4D:
Block4E:
Block4F:
Block50:
Block51:
Block52:
Block53:
Block54:
Block55:
Block56:
Block57:
Block58:
Block59:
Block5A:
Block5B:
Block5C:
Block5D:
Block5E:
Block5F:
Block60:
Block61:
Block62:
Block63:
Block64:
Block65:
Block66:
Block67:
Block68:
Block69:
Block6A:
Block6B:
Block6C:
Block6D:
Block6E:
Block6F:
Block70:
Block71:
Block72:
Block73:
Block74:
Block75:
Block76:
Block77:
Block78:
Block79:
Block7A:
Block7B:
Block7C:
Block7D:
Block7E:
Block7F:
Block80:
Block81:
Block82:
Block83:
Block84:
Block85:
Block86:
Block87:
Block88:
Block89:
Block8A:
Block8B:
Block8C:
Block8D:
Block8E:
Block8F:
Block90:
Block91:
Block92:
Block93:
Block94:
Block95:
Block96:
Block97:
Block98:
Block99:
Block9A:
Block9B:
Block9C:
Block9D:
Block9E:
Block9F:
BlockA0:
BlockA1:
BlockA2:
BlockA3:
BlockA4:
BlockA5:
BlockA6:
BlockA7:
BlockA8:
BlockA9:
BlockAA:
BlockAB:
BlockAC:
BlockAD:
BlockAE:
BlockAF:
BlockB0:
BlockB1:
BlockB2:
BlockB3:
BlockB4:
BlockB5:
BlockB6:
BlockB7:
BlockB8:
BlockB9:
BlockBA:
BlockBB:
BlockBC:
BlockBD:
BlockBE:
BlockBF:
BlockC0:
BlockC1:
BlockC2:
BlockC3:
BlockC4:
BlockC5:
BlockC6:
BlockC7:
BlockC8:
BlockC9:
BlockCA:
BlockCB:
BlockCC:
BlockCD:
BlockCE:
BlockCF:
BlockD0:
BlockD1:
BlockD2:
BlockD3:
BlockD4:
BlockD5:
BlockD6:
BlockD7:
BlockD8:
BlockD9:
BlockDA:
BlockDB:
BlockDC:
BlockDD:
BlockDE:
BlockDF:
BlockE0:
BlockE1:
BlockE2:
BlockE3:
BlockE4:
BlockE5:
BlockE6:
BlockE7:
BlockE8:
BlockE9:
BlockEA:
BlockEB:
BlockEC:
BlockED:
BlockEE:
BlockEF:
BlockF0:
BlockF1:
BlockF2:
BlockF3:
BlockF4:
BlockF5:
BlockF6:
BlockF7:
BlockF8:
BlockF9:
BlockFA:
BlockFB:
BlockFC:
BlockFD:
BlockFE:
BlockFF:
RTS
Block100:
LDA $04
BNE .end
LDA $AA,x
BMI .end
LDA #$00
STA $AA,x
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
CLC
ADC #$0010
PHA
LDA $06A0
AND #$0018
BEQ .store
PLA
CLC
ADC #$0010
PHA
.store
PLA
SEP #$20
STA $14D4,x
XBA
STA $D8,x
.end
RTS
Block101:
Block102:
Block103:
Block104:
Block105:
Block106:
Block107:
Block108:
Block109:
Block10A:
Block10B:
Block10C:
Block10D:
Block10E:
Block10F:
Block110:
Block111:
Block112:
Block113:
Block114:
Block115:
Block116:
Block117:
Block118:
Block119:
Block11A:
Block11B:
Block11C:
Block11D:
Block11E:
Block11F:
Block120:
Block121:
Block122:
Block123:
Block124:
Block125:
Block126:
Block127:
Block128:
Block129:
Block12A:
Block12B:
Block12C:
Block12D:
Block12E:
Block12F:
Block130:
Block131:
Block132:
Block133:
Block134:
Block135:
Block136:
Block137:
Block138:
Block139:
Block13A:
Block13B:
Block13C:
Block13D:
Block13E:
Block13F:
Block140:
Block141:
Block142:
Block143:
Block144:
Block145:
Block146:
Block147:
Block148:
Block149:
Block14A:
Block14B:
Block14C:
Block14D:
Block14E:
Block14F:
Block150:
Block151:
Block152:
Block153:
Block154:
Block155:
Block156:
Block157:
Block158:
Block159:
Block15A:
Block15B:
Block15C:
Block15D:
Block15E:
Block15F:
Block160:
Block161:
Block162:
Block163:
Block164:
Block165:
Block166:
Block167:
Block168:
Block169:
Block16A:
Block16B:
Block16C:
Block16D:
Block16E:
Block16F:
Block170:
Block171:
Block172:
Block173:
Block174:
Block175:
Block176:
Block177:
Block178:
Block179:
Block17A:
Block17B:
Block17C:
Block17D:
Block17E:
Block17F:
Block180:
Block181:
Block182:
Block183:
Block184:
Block185:
Block186:
Block187:
Block188:
Block189:
Block18A:
Block18B:
Block18C:
Block18D:
Block18E:
Block18F:
Block190:
Block191:
Block192:
Block193:
Block194:
Block195:
Block196:
Block197:
Block198:
Block199:
Block19A:
Block19B:
Block19C:
Block19D:
Block19E:
Block19F:
Block1A0:
Block1A1:
Block1A2:
Block1A3:
Block1A4:
Block1A5:
Block1A6:
Block1A7:
Block1A8:
Block1A9:
Block1AA:
Block1AB:
Block1AC:
Block1AD:
Block1AE:
Block1AF:
Block1B0:
Block1B1:
Block1B2:
Block1B3:
Block1B4:
Block1B5:
Block1B6:
Block1B7:
Block1B8:
Block1B9:
Block1BA:
Block1BB:
Block1BC:
Block1BD:
Block1BE:
Block1BF:
Block1C0:
Block1C1:
Block1C2:
Block1C3:
Block1C4:
Block1C5:
Block1C6:
Block1C7:
Block1C8:
Block1C9:
Block1CA:
Block1CB:
Block1CC:
Block1CD:
Block1CE:
Block1CF:
Block1D0:
Block1D1:
Block1D2:
Block1D3:
Block1D4:
Block1D5:
Block1D6:
Block1D7:
Block1D8:
Block1D9:
Block1DA:
Block1DB:
Block1DC:
Block1DD:
Block1DE:
Block1DF:
Block1E0:
Block1E1:
Block1E2:
Block1E3:
Block1E4:
Block1E5:
Block1E6:
Block1E7:
Block1E8:
Block1E9:
Block1EA:
Block1EB:
Block1EC:
Block1ED:
Block1EE:
Block1EF:
Block1F0:
Block1F1:
Block1F2:
Block1F3:
Block1F4:
Block1F5:
Block1F6:
Block1F7:
Block1F8:
Block1F9:
Block1FA:
Block1FB:
Block1FC:
Block1FD:
Block1FE:
Block1FF:
RTS


TurnaroundHijack:
LDA #$01
STA $04
LDA $B6,x
EOR #$FF
RTL

LevelLoadHijack:
LDA #$80
STA $1DFB
PHX
LDX #$0B
LevelLoadLoop:
STZ $0670,x
DEX
BPL LevelLoadLoop
PLX
RTL

PlayerCode:
JSL $04DAAD
LDA $0DB2
BEQ OnePlayer
STZ $0DB2
LDA #$01
STA $06A2
LDA #$04
STA $06A1
OnePlayer:
RTL

CoinLife:
LDA $06A1
CMP #$63
BEQ CoinLifeRet
INC $06A1
CoinLifeRet:
LDA $0DBF
SEC
RTL

DSXStart:		;DSX.asm code
	SEI
	PHP
	REP #$30
	PHA
	PHX
	PHY
	PHB
	SEP #$30	;8bit AXY

	LDA #$01	;FastROM on
	STA $420D

	LDA $0100	;check game mode to see if in game
	CMP #$14	;must be in this mode
	BNE Return
	LDA !SLOTSUSED	;and only if there's actual stuff to transfer
	BEQ Return

Proceed:
	REP #$20	;16bit A
	LDY #$80	;word writes
	STY $2115

	LDA #$7C00	;dest VRAM
	STA $2116

	LDY #$01	;2 regs write once alternate
	STY $4300
	LDY #$18	;2118
	STY $4301
	LDA #$0B44	;7F:0B44
	STA $4302
	LDY #$7F	;!7F!
	STY $4304
	LDA #$0800	;2kb
	STA $4305

	LDY #$01
	STY $420B	;transfer	

Return:
	STZ !SLOTSUSED	;reset slots used

	SEP #$30	;8bit AXY	
	LDA #$80	;set bank to zero in FastROM area
	PHA
	PLB	
	JML $808176	;jump to code just after pushing, into FastROM area


Graphics:
INCBIN Luigi.bin

END_FREESPACE:

org $03E05C
GenMushroom:
JSR $C318
RTL

org $0190A2
JSL TurnaroundHijack

org $0491E0
JSL LevelLoadHijack
NOP

org $01FFBF
UpdateXposNoGrvty:
JSR $ABCC
RTL
EndLevel:
JSR $C0E7
RTL
GenShellessKoopa:
JSR $96E1
RTL

org $04FFB1
EndRT:
JSR $E5EE
RTS







